/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "string"
#include "vector"
#include "building_extents.h"
#include "building_flags.h"
#include "building_type.h"
#include "job_type.h"
namespace df {
  struct building_drawbuffer;
  struct building_squad_use;
  struct building_users;
  struct file_compressorst;
  struct general_ref;
  struct hospital_supplies;
  struct item;
  struct job;
  struct machine_info;
  struct machine_tile_set;
  struct map_viewport;
  struct power_info;
  struct specific_ref;
  struct stockpile_links;
  struct unit;
  struct workshop_profile;
  struct DFHACK_EXPORT building : virtual_class {
    int32_t x1; /*!< top left */
    int32_t y1;
    int32_t centerx; /*!< work location */
    int32_t x2; /*!< bottom right */
    int32_t y2;
    int32_t centery;
    int32_t z;
    df::building_flags flags;
    int16_t mat_type;
    int32_t mat_index;
    df::building_extents room;
    int32_t age;
    int16_t race;
    int32_t id;
    std::vector<df::job* > jobs;
    std::vector<df::specific_ref* > specific_refs;
    std::vector<df::general_ref* > general_refs;
    bool is_room;
    std::vector<df::building* > children; /*!< other buildings within this room */
    std::vector<df::building* > parents; /*!< rooms this building belongs to */
    int32_t owner_id; /*!< since v0.40.01 */
    df::unit* owner;
    struct DFHACK_EXPORT T_job_claim_suppress {
      df::unit* unit;
      int32_t timer;
      static struct_identity _identity;
    public:
      T_job_claim_suppress();
    };
    std::vector<T_job_claim_suppress* > job_claim_suppress; /*!< after Remv Cre, prevents unit from taking jobs at building */
    std::string name;
    struct DFHACK_EXPORT T_activities {
      int32_t activity_id;
      int32_t event_id;
      static struct_identity _identity;
    public:
      T_activities();
    };
    std::vector<T_activities* > activities;
    int32_t world_data_id; /*!< since v0.34.01 */
    int32_t world_data_subid; /*!< since v0.34.01 */
    int32_t unk_v40_2; /*!< since v0.40.01 */
    int32_t site_id; /*!< since v0.42.01 */
    int32_t location_id; /*!< since v0.42.01 */
    int32_t unk_v40_3; /*!< since v0.40.01 */
    static virtual_identity _identity;
    typedef building* key_pointer_type;
    typedef int32_t key_field_type;
    static int binsearch_index(const std::vector<building*> &vec, key_field_type key, bool exact = true);
    static int binsearch_index(const std::vector<building*> &vec, key_pointer_type key, bool exact = true);
    static std::vector<building*> &get_vector();
    static std::vector<building*> *get_vector_ptr();
    static building *find(key_field_type id);
  public:
    virtual int32_t getCustomType() { return int32_t(); /*0*/ };
    virtual void setCustomType(int32_t) { /*1*/ };
    virtual void countHospitalSupplies(df::hospital_supplies*) { /*2*/ };
    virtual void countTavernSupplies(void*) { /*3*/ };
    virtual df::stockpile_links* getStockpileLinks() { return 0; /*4*/ };
    virtual void detachWorldData() { /*5*/ }; /*!< ? */
    virtual bool canLinkToStockpile() { return bool(); /*6*/ }; /*!< used by the give to building ui of stockpile */
    virtual df::building_users* getUsers() { return 0; /*7*/ };
    virtual void moveBuilding(int16_t, int16_t, int16_t) { /*8*/ };
    virtual void initOccupancy(int32_t, int32_t) { /*9*/ };
    virtual void setFillTimer(int32_t, int16_t) { /*10*/ };
    virtual bool isOnFire() { return bool(); /*11*/ };
    virtual bool isUnpowered() { return bool(); /*12*/ }; /*!< from magma OR machine power */
    virtual bool canCollapse() { return bool(); /*13*/ };
    virtual uint32_t getPassableOccupancy() { return uint32_t(); /*14*/ };
    virtual uint32_t getImpassableOccupancy() { return uint32_t(); /*15*/ };
    virtual bool isPowerSource() { return bool(); /*16*/ };
    virtual void updateFromWeather() { /*17*/ };
    virtual void updateTemperature() { /*18*/ };
    virtual void updateItems() { /*19*/ };
    virtual void updateTempFromTile(uint16_t, bool, bool) { /*20*/ };
    virtual bool isNormalFurniture() { return bool(); /*21*/ };
    virtual bool isFarmPlot() { return bool(); /*22*/ };
    virtual df::workshop_profile* getWorkshopProfile() { return 0; /*23*/ };
    virtual df::machine_info* getMachineInfo() { return 0; /*24*/ };
    virtual void getPowerInfo(df::power_info*) { /*25*/ };
    virtual bool canConnectToMachine(df::machine_tile_set*) { return bool(); /*26*/ };
    virtual df::building_type getType() { return df::building_type(); /*27*/ };
    virtual int16_t getSubtype() { return int16_t(); /*28*/ };
    virtual void setSubtype(int16_t) { /*29*/ };
    virtual bool isActual() { return bool(); /*30*/ };
    virtual bool isCoffin2() { return bool(); /*31*/ };
    virtual void updateAction() { /*32*/ };
    virtual bool isStatueOrRestraint() { return bool(); /*33*/ };
    virtual void setMaterialAmount(int32_t) { /*34*/ };
    virtual void setBuildStage(int16_t) { /*35*/ };
    virtual int32_t getBuildStage() { return int32_t(); /*36*/ };
    virtual int32_t getMaxBuildStage() { return int32_t(); /*37*/ };
    virtual int32_t getArchitectureValue() { return int32_t(); /*38*/ }; /*!< bridge: material*10 rough, material*30 smooth */
    virtual bool isSettingOccupancy() { return bool(); /*39*/ };
    virtual bool isActual2() { return bool(); /*40*/ };
    virtual bool isExtentShaped() { return bool(); /*41*/ };
    virtual void updateOccupancy(int32_t, int32_t) { /*42*/ };
    virtual int32_t getRoomValue(df::unit*) { return int32_t(); /*43*/ };
    virtual int32_t getPersonalValue(df::unit*) { return int32_t(); /*44*/ };
    virtual bool canBeRoom() { return bool(); /*45*/ };
    virtual int32_t getConstructionValue() { return int32_t(); /*46*/ }; /*!< bridge: material*10 */
    virtual void queueDestroy() { /*47*/ }; /*!< same as querying and pressing X */
    virtual bool isImpassableTile(int32_t, int32_t) { return bool(); /*48*/ };
    virtual int32_t getFreeCapacity(bool) { return int32_t(); /*49*/ };
    virtual bool canStoreItem(df::item*, bool) { return bool(); /*50*/ };
    virtual void getName(std::string*) { /*51*/ };
    virtual void getNameColor() { /*52*/ };
    virtual void initFarmSeasons() { /*53*/ };
    virtual void initBurialFlags() { /*54*/ };
    virtual void clearBurialFlags() { /*55*/ };
    virtual void clearBurialFlags2() { /*56*/ };
    virtual int32_t getClutterLevel() { return int32_t(); /*57*/ }; /*!< 1..10 */
    virtual bool needsDesign() { return bool(); /*58*/ };
    virtual bool canUseForMood(df::job_type) { return bool(); /*59*/ };
    virtual bool canBeRoomSubset() { return bool(); /*60*/ };
    virtual bool isCoffin() { return bool(); /*61*/ };
    virtual bool canUseSpouseRoom() { return bool(); /*62*/ };
    virtual bool canMakeRoom() { return bool(); /*63*/ }; /*!< false if already, or cannot be */
    virtual bool isJusticeRestraint() { return bool(); /*64*/ };
    virtual void detachRestrainedUnit(df::unit*) { /*65*/ };
    virtual void write_file(df::file_compressorst*) { /*66*/ };
    virtual void read_file(df::file_compressorst*, int32_t) { /*67*/ };
    virtual bool isImpassableAtCreation() { return bool(); /*68*/ }; /*!< the true set looks like things where the unit should stand aside */
    virtual void categorize(bool) { /*69*/ }; /*!< Add to world.buildings.other.* */
    virtual void uncategorize() { /*70*/ }; /*!< Remove from world.buildings.other.* */
    virtual int32_t getBaseValue() { return int32_t(); /*71*/ };
    virtual void setTriggerState(int32_t) { /*72*/ };
    virtual void checkAdvmodeLocked() { /*73*/ };
    virtual void drawAdvmodeUnlockUI() { /*74*/ };
    virtual void advmodeUnlock(void*) { /*75*/ };
    virtual bool needsMagma() { return bool(); /*76*/ };
    virtual void removeUses(bool, bool) { /*77*/ };
    virtual void deconstructItems(bool, bool) { /*78*/ };
    virtual void cleanupMap() { /*79*/ };
    virtual bool isFireSafe(int8_t) { return bool(); /*80*/ }; /*!< checks contained_items[0] for FIREIMMUNE */
    virtual void fillSidebarMenu() { /*81*/ };
    virtual bool isForbidden() { return bool(); /*82*/ };
  protected:
    virtual bool anon_vmethod_83() { return bool(); /*83*/ };
  public:
    virtual bool isHidden() { return bool(); /*84*/ };
    virtual bool isVisibleInUI() { return bool(); /*85*/ }; /*!< not hidden, or hide/unhide UI mode */
    virtual bool isVisibleInViewport(df::map_viewport*) { return bool(); /*86*/ }; /*!< checks coordinates, calls isVisibleInUI and checks window_xy */
    virtual void getDrawExtents(df::building_drawbuffer*) { /*87*/ };
    virtual void drawBuilding(df::building_drawbuffer*, int16_t) { /*88*/ };
    virtual void setSquadUse(int32_t, uint32_t) { /*89*/ };
    virtual std::vector<df::building_squad_use* >* getSquads() { return 0; /*90*/ };
    virtual int32_t getSpecificSquad() { return int32_t(); /*91*/ };
    virtual int32_t getSpecificPosition() { return int32_t(); /*92*/ };
    virtual void setSpecificSquadPos(int32_t, int32_t) { /*93*/ };
    virtual void clearSpecificSquad() { /*94*/ };
  protected:
    virtual void anon_vmethod_95() { /*95*/ }; /*!< since v0.42.01; related to tavern beds */
  public:
    virtual ~building() { /*96*/ };
  protected:
    building(virtual_identity *_id = &building::_identity);
    friend void *df::allocator_fn<building>(void*,const void*);
  };
}
