/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
#include "coord.h"
#include "cumulus_type.h"
#include "fog_type.h"
#include "front_type.h"
#include "region_map_entry_flags.h"
#include "stratus_type.h"
namespace df {
  struct world_site;
  struct DFHACK_EXPORT region_map_entry {
    int32_t unk_0;
    int32_t finder_rank;
    std::vector<df::world_site* > sites;
    BitArray<df::region_map_entry_flags> flags;
    int16_t elevation; /*!< 0-99=Ocean, 150+=Mountains, 100-149: all other biomes. Note that PSV elevation uses 100-299 for normal biomes, with range later cut to 1/4, and Mountains shifted down */
    int16_t rainfall; /*!< 0-100 */
    int16_t vegetation; /*!< 0-100 */
    int16_t temperature; /*!< Urists. 10000 Urists=0 Celsius */
    int16_t evilness; /*!< 0-32=Good, 33-65=Neutral, 66-100=Evil */
    int16_t drainage; /*!< 0-100 */
    int16_t volcanism; /*!< 0-100 */
    int16_t savagery; /*!< 0-32=Calm, 33-65=Neutral, 66-100=Savage */
    int16_t air_temp;
    int16_t air_x; /*!< Toady: a velocity component?  I dont remember */
    int16_t air_y;
    union T_clouds {
      uint16_t whole;
      struct {
        df::front_type front : 2;
        df::cumulus_type cumulus : 2;
        uint16_t cirrus : 1;
        df::stratus_type stratus : 2;
        df::fog_type fog : 2;
        uint16_t countdown : 4; /*!< A counter for stratus clouds that randomly decreases by 1 or 0 each timer weather is checked there. it does various stratus/fog effects based on the humidity/breezes/etc. */
      } bits;
      enum Shift {
        shift_front = 0,
        shift_cumulus = 2,
        shift_cirrus = 4,
        shift_stratus = 5,
        shift_fog = 7,
        shift_countdown = 9
      };
      enum Mask : uint16_t {
        mask_front = 0x3U,
        mask_cumulus = 0xcU,
        mask_cirrus = 0x10U,
        mask_stratus = 0x60U,
        mask_fog = 0x180U,
        mask_countdown = 0x1e00U
      };
      T_clouds(uint16_t whole_ = 0) : whole(whole_) {};
    };
    T_clouds clouds;
    /**
     * blows toward direction in morning
     */
    union T_wind {
      uint16_t whole;
      struct {
        uint16_t north_1 : 1;
        uint16_t south_1 : 1;
        uint16_t east_1 : 1;
        uint16_t west_1 : 1;
        uint16_t north_2 : 1;
        uint16_t south_2 : 1;
        uint16_t east_2 : 1;
        uint16_t west_2 : 1;
      } bits;
      enum Shift {
        shift_north_1 = 0,
        shift_south_1 = 1,
        shift_east_1 = 2,
        shift_west_1 = 3,
        shift_north_2 = 4,
        shift_south_2 = 5,
        shift_east_2 = 6,
        shift_west_2 = 7
      };
      enum Mask : uint16_t {
        mask_north_1 = 0x1U,
        mask_south_1 = 0x2U,
        mask_east_1 = 0x4U,
        mask_west_1 = 0x8U,
        mask_north_2 = 0x10U,
        mask_south_2 = 0x20U,
        mask_east_2 = 0x40U,
        mask_west_2 = 0x80U
      };
      T_wind(uint16_t whole_ = 0) : whole(whole_) {};
    };
    T_wind wind; /*!< blows toward direction in morning */
    int16_t snowfall; /*!< 0-5000, humidity? */
    int16_t salinity; /*!< 0-100 */
    df::coord unk_3e;
    df::coord unk_44;
    df::coord unk_4a;
    int32_t region_id;
    int32_t landmass_id;
    int16_t geo_index;
    static struct_identity _identity;
  public:
    region_map_entry();
  };
  template<> struct DFHACK_EXPORT bitfield_traits<region_map_entry::T_clouds> {
    typedef uint16_t base_type;
    typedef region_map_entry::T_clouds bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<region_map_entry::T_clouds> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT bitfield_traits<region_map_entry::T_wind> {
    typedef uint16_t base_type;
    typedef region_map_entry::T_wind bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<region_map_entry::T_wind> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
}
