/* THIS FILE WAS GENERATED. DO NOT EDIT. */
#pragma once
#ifdef __GNUC__
#pragma GCC system_header
#endif
#include "DataDefs.h"
#include "Export.h"
#include "cstdint"
#include "vector"
#include "emotion_type.h"
#include "goal_type.h"
#include "need_type.h"
#include "personality_facet_type.h"
#include "unit_emotion_memory.h"
#include "unit_thought_type.h"
#include "value_type.h"
namespace df {
  struct DFHACK_EXPORT unit_personality {
    struct DFHACK_EXPORT T_values {
      df::value_type type;
      int32_t strength;
      static struct_identity _identity;
    public:
      T_values();
    };
    std::vector<T_values* > values; /*!< since v0.40.01 */
    struct DFHACK_EXPORT T_unk_v40_2 {
      int16_t unk1;
      int16_t unk2;
      static struct_identity _identity;
    public:
      T_unk_v40_2();
    };
    std::vector<T_unk_v40_2* > unk_v40_2; /*!< since v0.40.01 */
    struct DFHACK_EXPORT T_emotions {
      df::emotion_type type;
      int32_t unk2;
      int32_t strength;
      df::unit_thought_type thought;
      int32_t subthought; /*!< for certain thoughts */
      int32_t severity;
      union T_flags {
        int32_t whole;
        struct {
          int32_t unk0 : 1;
          int32_t unk1 : 1;
          int32_t unk2 : 1;
          int32_t unk3 : 1;
          int32_t remembered_longterm : 1;
          int32_t remembered_shortterm : 1;
          int32_t remembered_reflected_on : 1;
        } bits;
        enum Shift {
          shift_unk0 = 0,
          shift_unk1 = 1,
          shift_unk2 = 2,
          shift_unk3 = 3,
          shift_remembered_longterm = 4,
          shift_remembered_shortterm = 5,
          shift_remembered_reflected_on = 6
        };
        enum Mask : int32_t {
          mask_unk0 = 0x1U,
          mask_unk1 = 0x2U,
          mask_unk2 = 0x4U,
          mask_unk3 = 0x8U,
          mask_remembered_longterm = 0x10U,
          mask_remembered_shortterm = 0x20U,
          mask_remembered_reflected_on = 0x40U
        };
        T_flags(int32_t whole_ = 0) : whole(whole_) {};
      };
      T_flags flags;
      int32_t unk7;
      int32_t year;
      int32_t year_tick;
      static struct_identity _identity;
    public:
      T_emotions();
    };
    std::vector<T_emotions* > emotions; /*!< since v0.40.01 */
    struct DFHACK_EXPORT T_dreams {
      int32_t unk1;
      df::goal_type type;
      int32_t unk3;
      std::vector<int32_t > unk4;
      int32_t unk8;
      static struct_identity _identity;
    public:
      T_dreams();
    };
    std::vector<T_dreams* > dreams; /*!< since v0.40.01 */
    int32_t next_dream_id; /*!< since v0.40.01 */
    struct DFHACK_EXPORT T_unk_v40_6 {
      int32_t unk1;
      int32_t unk2;
      int32_t unk3;
      int32_t unk4;
      int32_t unk5;
      int32_t unk6;
      static struct_identity _identity;
    public:
      T_unk_v40_6();
    };
    std::vector<T_unk_v40_6* > unk_v40_6; /*!< since v0.40.01 */
    uint16_t traits[50];
    int32_t civ_id; /*!< since v0.40.01 */
    int32_t cultural_identity; /*!< since v0.40.01 */
    struct DFHACK_EXPORT T_unk5 {
      int16_t unk1;
      int16_t unk2;
      static struct_identity _identity;
    public:
      T_unk5();
    };
    std::vector<T_unk5* > unk5;
    std::vector<int16_t > unk6;
    int32_t stress_level;
    int32_t stress_drain; /*!< since v0.40.14; range 0-806400, higher values cause stress to decrease quicker */
    int32_t stress_boost; /*!< since v0.40.14; range 0-806400, higher values cause stress to increase quicker */
    int32_t likes_outdoors; /*!< migrated from misc_traits */
    int32_t combat_hardened; /*!< migrated from misc_traits */
    struct DFHACK_EXPORT T_needs {
      df::need_type id;
      int32_t deity_id; /*!< for pray need */
      int32_t focus_level; /*!< goes to 400 when unit satisfies need */
      int32_t need_level; /*!< how fast focus_level decreases when it below 0 */
      static struct_identity _identity;
    public:
      T_needs();
    };
    std::vector<T_needs* > needs; /*!< since v0.42.01 */
    /**
     * Since v0.42.01
     */
    union T_flags {
      uint32_t whole;
      struct {
        uint32_t anon_1 : 1;
        uint32_t has_unmet_needs : 1; /*!< focus_level is below -999 for at least one need */
      } bits;
      enum Shift {
        shift_anon_1 = 0,
        shift_has_unmet_needs = 1
      };
      enum Mask : uint32_t {
        mask_anon_1 = 0x1U,
        mask_has_unmet_needs = 0x2U
      };
      T_flags(uint32_t whole_ = 0) : whole(whole_) {};
    };
    T_flags flags; /*!< since v0.42.01 */
    typedef int16_t T_temporary_trait_changes[50];
    T_temporary_trait_changes* temporary_trait_changes; /*!< sum of inebriation or so personality changing effects */
    int32_t unk_v4201_3; /*!< since v0.42.01 */
    int32_t unk_v4201_4; /*!< since v0.42.01 */
    struct DFHACK_EXPORT T_memories {
      df::unit_emotion_memory shortterm[8];
      df::unit_emotion_memory longterm[8];
      struct DFHACK_EXPORT T_reflected_on {
        df::unit_emotion_memory memory;
        df::personality_facet_type changed_facet;
        int32_t anon_1;
        int32_t anon_2;
        df::value_type changed_value;
        int32_t anon_3;
        int32_t anon_4;
        static struct_identity _identity;
      public:
        T_reflected_on();
      };
      std::vector<T_reflected_on* > reflected_on;
      static struct_identity _identity;
    public:
      T_memories();
    };
    T_memories* memories;
    int32_t unk_v47_1; /*!< since v0.47.01 */
    int32_t unk_v47_2; /*!< since v0.47.01 */
    int32_t unk_v47_3; /*!< since v0.47.01; Seems to be 0-100 */
    int32_t unk_v47_4; /*!< since v0.47.01; Seems to be 0-100 */
    int32_t current_focus; /*!< weighted sum of needs focus_level-s */
    int32_t undistracted_focus; /*!< usually number of needs multiplied by 4 */
    static struct_identity _identity;
  public:
    unit_personality();
  };
  template<> struct DFHACK_EXPORT bitfield_traits<unit_personality::T_emotions::T_flags> {
    typedef int32_t base_type;
    typedef unit_personality::T_emotions::T_flags bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<unit_personality::T_emotions::T_flags> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
  template<> struct DFHACK_EXPORT bitfield_traits<unit_personality::T_flags> {
    typedef uint32_t base_type;
    typedef unit_personality::T_flags bitfield_type;
    static const int bit_count = sizeof(base_type)*8;
    static const bitfield_item_info bits[bit_count];
  };
  template<> struct DFHACK_EXPORT identity_traits<unit_personality::T_flags> {
    static bitfield_identity identity;
    static bitfield_identity *get() { return &identity; }
  };
}
